//
//  AppDelegate.m
//  PDFViewer
//
//  Created by Markus Bröker on 27.03.17.
//  Copyright © 2017 Markus Bröker. All rights reserved.
//

#import "AppDelegate.h"

@implementation AppDelegate
@synthesize controller = _controller;

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(newDocumentLoaded:) name:@"newDocumentLoaded" object:nil];
}

- (void)newDocumentLoaded:(NSNotification*) notification {
    NSString *lastUrl = [notification object];
    
    NSLog(@"Setze die letzte URL auf %@", lastUrl);
    
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    [defaults setObject:lastUrl forKey:@"lastURL"];
    [defaults synchronize];
}

- (void)applicationWillFinishLaunching:(NSNotification *)notification {
    _window = [[[NSApplication sharedApplication] windows] objectAtIndex:0];
    _controller = (ViewController*) [_window contentViewController];
}

- (void)applicationWillTerminate:(NSNotification *)aNotification {
    // Insert code here to tear down your application
}

- (BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)sender {
    return TRUE;
}

- (BOOL) application:(NSApplication *)sender openFile:(NSString *)filename {
    NSURL *url = [[NSURL alloc] initFileURLWithPath:filename];
    BOOL status = [[_controller pdfViewer] loadUrl: url];
    
    if (!status) {
        [[_controller pdfViewer] speak:(NSMutableString*)@"Das Dokument konnte nicht geladen werden"];
    } else {
        [[_controller pdfViewer] startSpeaking:nil];
    }
    
    return status;
}

- (void) application:(NSApplication *)sender openFiles:(NSArray<NSString *> *)filenames {
    for (id filename in filenames) {
        [self application:sender openFile:filename];
    }
}

@end
